
#ifndef _MYUTILS_
#define _MYUTILS_

#include <stdio.h>
//#define MYDEBUG 1

extern int num_threads;

void my_die(const char *x, const char * file, int line);

#define MYDIE(x) my_die(x, __FILE__, __LINE__);
#define MYASSERT(x) if (!(x)) my_die (#x, __FILE__, __LINE__);

#define feq(a,b) (fabs((a) - (b)) < 1E-10)

template <class T> void debug_print_array(int n, T *array, const char *format, const char *name)
{
#ifdef MYDEBUG
	printf(name);
   printf(": {");
	int i;
	for (i = 0; i < n; ++ i)
	{
		printf(format, array[i]);
	}
   printf("}\n\n");
#endif
}

#endif //_MYUTILS_
