#ifndef SOLVE_SERIAL_H_
#define SOLVE_SERIAL_H_

#include "sparse_matrix.h"
#include <builtin_types.h>


void solve_serial(sparse_matrix A, float x[], const float xB[], float y[], const float yB[], unsigned int array_dim);
void solve_cuda(sparse_matrix A, float x[], const float xB[], float y[], const float yB[], unsigned int array_dim);

void DimCalc(unsigned int jobs, dim3 & BlockDim, dim3 & ThreadDim);
void dump(float * d_A, float * d_xB, float * d_yB, unsigned int size);
void DumpReductionBuffer(float * d_Buf1, float * d_Buf2, unsigned int size);
void dump_dev_array(float *d_A, unsigned int array_height, unsigned int array_width);
void dump_dev_array(unsigned int *d_A, unsigned int array_height, unsigned int array_width);


__global__ void FindSwapRow(float * d_in, unsigned int * d_swap_row, unsigned int pivot_row, unsigned int array_width, unsigned int array_height);
__global__ void SwapAndNormalizePivotRow(float * d_in, unsigned int * d_swap_row, unsigned int pivot_row, unsigned int array_width, unsigned int num_jobs);
//__global__ void SwapAndNormalizePivotRow(float *d_Maug, unsigned int pivot_row, const unsigned int array_height, const unsigned int array_width);
__global__ void EliminateRows(float *d_Maug, unsigned int pivot_row, unsigned int array_height, unsigned int array_width, unsigned int num_jobs);
__global__ void SubtractValue(float *d_Maug, unsigned int value_row, unsigned int array_height, unsigned int array_width, unsigned int array_dim, unsigned int num_jobs);


#endif
