#ifndef SPARSE_MATRIX_H_
#define SPARSE_MATRIX_H_

#include "myutils.h"
#include <vector>

using namespace std;

//This class cleverly implements a sparse matrix as a regular matrix. Ha!
class sparse_matrix
{
public:
	sparse_matrix();
	sparse_matrix(const sparse_matrix & rhs);
	~sparse_matrix();
	void init(unsigned int num_rows, unsigned int num_cols);
	void add_to_entry_expand(unsigned int row, unsigned int col, float value);
	void add_to_entry(unsigned int row, unsigned int col, float value);
	float get_entry(unsigned int row, unsigned int col);
	void set_entry(unsigned int row, unsigned int col, float value);
	unsigned int get_num_cols();
	unsigned int get_num_rows();
	void swap(unsigned int row1, unsigned int row2);
	void debug_print(const char * description);
	
private:
	vector<vector<float> *> m_matrix;
	unsigned int m_rows;
	unsigned int m_columns;
};

#endif
